import os
import pathlib
import unittest

from pyplaml import *


# noinspection PyBroadException
class PyPlamlTest(unittest.TestCase):
    def setUp(self):
        puml_files = pathlib.Path(__file__).parent.parent / 'examples' / 'plantuml'

        self.parser = PUMLParser()
        self.examples_sorted = sorted(puml_files.glob("*.puml"))

    def test_lexer(self):
        for example_file in self.examples_sorted:
            self.parser.lexer.testFile(str(example_file), False)

    def test_parser(self):
        for example_file in self.examples_sorted:
            try:
                self.assertIsNotNone(self.parser.parse_file(example_file), f"Parser error in {example_file}")
            except:
                self.assertTrue(False, f"Parser exception in {example_file}")

    def test_drawing(self):
        main_script = pathlib.Path(__file__).parent.parent / 'main.py'

        for e in self.examples_sorted:
            self.assertEqual(
                os.system(f"python {main_script} {e}"),
                0,
                f"Drawing \"{e}\" failed"
            )
